## Copyright (C) 2014 Fotios Kasolis
##
## This file is part of Octave.
##
## Octave is free software; you can redistribute it and/or modify it
## under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 3 of the License, or (at
## your option) any later version.
##
## Octave is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with Octave; see the file COPYING.  If not, see
## <http://www.gnu.org/licenses/>.

## -*- texinfo -*- 
## @deftypefn {Function File} isdiag (@var{A})
##
## Return true if @var{A} is a diagonal matrix
##
## @seealso{istriu, istril, isbanded}
## @end deftypefn

## Author: Fotios Kasolis <fotios.kasolis@gmail.com>
## Created: 2014-09-22

function [ ret ] = isdiag (A)

  if ( !isnumeric (A) || !ismatrix (A) || nargin != 1 )
    error ("expexted single numerical matrix input");
  endif

  if ( isempty (find (triu (A, +1))) && isempty (find (tril (A, -1))) )
    ret = 1;
  else
    ret = 0;
  endif

endfunction
